local require = GLOBAL.require
--local SpawnPrefab = GLOBAL.SpawnPrefab
--
--local Ingredient = GLOBAL.Ingredient
--local RECIPETABS = GLOBAL.RECIPETABS
--local STRINGS = GLOBAL.STRINGS
--local ACTIONS = GLOBAL.ACTIONS
--local Action = GLOBAL.Action
--
local InvSlot = require "widgets/invslot"
local TileBG = require "widgets/tilebg"
local Image = require "widgets/image"
local Widget = require "widgets/widget"
local EquipSlot = require "widgets/equipslot"
local ItemTile = require "widgets/itemtile"

PrefabFiles = {
	"winfred",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/winfred.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/winfred.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/winfred.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/winfred.xml" ),

	--Asset( "IMAGE", "images/inventoryimages/logicfilter.tex" ),
	--Asset( "ATLAS", "images/inventoryimages/logicfilter.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/winfred_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/winfred_silho.xml" ),

    Asset( "IMAGE", "bigportraits/winfred.tex" ),
    Asset( "ATLAS", "bigportraits/winfred.xml" ),
	
	Asset( "IMAGE", "minimap/winfredmini.tex" ),
    Asset( "ATLAS", "minimap/winfredmini.xml" ),
	
	Asset("SOUNDPACKAGE", "sound/winfred.fev"),
    Asset("SOUND", "sound/winfred.fsb"),

	--Asset("ATLAS", "images/inventoryimages/cybertab.xml")
	
}


--require "recipe"
--require "tuning"
--local InvSlot = require "widgets/invslot"
--local TileBG = require "widgets/tilebg"
--local Image = require "widgets/image"
--local Widget = require "widgets/widget"
--local EquipSlot = require "widgets/equipslot"
--local ItemTile = require "widgets/itemtile"



--Amends sleep function to apply boosted sanity and health gain to winfred, offsets hunger drain

-- BEDROLL || 33 Sanity || 0 Health || -75 Hunger

function deepsleepbag(inst)

   local oldonsleep = inst.components.sleepingbag.onsleep

    inst.components.sleepingbag.onsleep = function(inst, sleeper)
      oldonsleep(inst, sleeper)
        if sleeper.prefab == "winfred" then
        sleeper:DoTaskInTime(1.3, function()
            --sleeper.components.sanity:DoDelta(50)
			sleeper.components.sanity:DoDelta(TUNING.SANITY_TINY, false)
			--TINY = 5 || SMALL = 10 || MED = 15 || MEDLARGE = 20
		
			sleeper.components.health:DoDelta(TUNING.HEALING_MEDSMALL, false, "tent", true)
			--SMALL = 3 || MEDSMALL = 8 || MED = 20 || LARGE = 40
				
			sleeper.components.hunger:DoDelta(TUNING.CALORIES_SMALL, false, true)
			--TINY = 9 || SMALL = 13 || MEDSMALL = 19 || LARGE = 38
				
		end)
		end
		
    end
end

-- FURROLL || 33 Sanity || 30 Health || -75 Hunger   

function deepsleepfur(inst)

   local oldonsleep = inst.components.sleepingbag.onsleep

    inst.components.sleepingbag.onsleep = function(inst, sleeper)
      oldonsleep(inst, sleeper)
        if sleeper.prefab == "winfred" then
        sleeper:DoTaskInTime(1.3, function()
            --sleeper.components.sanity:DoDelta(50)
			sleeper.components.sanity:DoDelta(TUNING.SANITY_TINY, false)
			--TINY = 5 || SMALL = 10 || MED = 15 || MEDLARGE = 20
		
			sleeper.components.health:DoDelta(TUNING.HEALING_SMALL, false, "tent", true)
			--SMALL = 3 || MEDSMALL = 8 || MED = 20 || LARGE = 40
				
			sleeper.components.hunger:DoDelta(TUNING.CALORIES_SMALL, false, true)
			--TINY = 9 || SMALL = 13 || MEDSMALL = 19 || LARGE = 38
				
		end)
		end
		
    end
end

-- TENT || 50 Sanity || 60 Health || -75 Hunger

function deepsleeptent(inst)

   local oldonsleep = inst.components.sleepingbag.onsleep

    inst.components.sleepingbag.onsleep = function(inst, sleeper)
      oldonsleep(inst, sleeper)
        if sleeper.prefab == "winfred" then
        sleeper:DoTaskInTime(1.3, function()
            --sleeper.components.sanity:DoDelta(50)
			sleeper.components.sanity:DoDelta(TUNING.SANITY_SMALL, false)
			--TINY = 5 || SMALL = 10 || MED = 15 || MEDLARGE = 20
		
			sleeper.components.health:DoDelta(TUNING.HEALING_MEDSMALL, false, "tent", true)
			--SMALL = 3 || MEDSMALL = 8 || MED = 20 || LARGE = 40
				
			sleeper.components.hunger:DoDelta(TUNING.CALORIES_SMALL, false, true)
			--TINY = 9 || SMALL = 13 || MEDSMALL = 19 || LARGE = 38
				
        end)
		end
		
    end
end

-- LEANTO || 50 Sanity || 60 Health || -25 Hunger

function deepsleepseiesta(inst)

   local oldonsleep = inst.components.sleepingbag.onsleep

    inst.components.sleepingbag.onsleep = function(inst, sleeper)
      oldonsleep(inst, sleeper)
        if sleeper.prefab == "winfred" then
        sleeper:DoTaskInTime(1.3, function()
            --sleeper.components.sanity:DoDelta(50)
			sleeper.components.sanity:DoDelta(TUNING.SANITY_SMALL, false)
			--TINY = 5 || SMALL = 10 || MED = 15 || MEDLARGE = 20
		
			sleeper.components.health:DoDelta(TUNING.HEALING_MEDSMALL, false, "tent", true)
			--SMALL = 3 || MEDSMALL = 8 || MED = 20 || LARGE = 40
				
			--sleeper.components.hunger:DoDelta(TUNING.CALORIES_SMALL, false, true)
			--TINY = 9 || SMALL = 13 || MEDSMALL = 19 || LARGE = 38
				
		--sleeper.components.temperature:SetTemperature(TUNING.TARGET_SLEEP_TEMP)			
        end)
		end
		
    end
end

--adds the deepsleep function to bedroll_straw, bedroll_furry, and tent
AddPrefabPostInit("bedroll_straw", deepsleepbag)
AddPrefabPostInit("bedroll_furry", deepsleepfur)
AddPrefabPostInit("tent", deepsleeptent)
AddPrefabPostInit("siestahut", deepsleepsiesta)


AddMinimapAtlas("minimap/winfredmini.xml")
RemapSoundEvent( "dontstarve/characters/winfred/death_voice", "winfred/sound/death_voice" )
RemapSoundEvent( "dontstarve/characters/winfred/hurt", "winfred/sound/hurt" )
RemapSoundEvent( "dontstarve/characters/winfred/talk_LP", "winfred/sound/talk_LP" )

-- First up, the character select screen lines
-- note: these are lower-case character name
GLOBAL.STRINGS.CHARACTER_TITLES.winfred = "The Mechanical Maiden"
GLOBAL.STRINGS.CHARACTER_NAMES.winfred = "winfred"
GLOBAL.STRINGS.CHARACTER_DESCRIPTIONS.winfred = "* Temperature Regulator\n* Regenerative Sleep\n* Hates Rain, Biofuel Dependent"
GLOBAL.STRINGS.CHARACTER_QUOTES.winfred = "\"For a brief time I was human.\""

-- You can also add any kind of custom dialogue that you would like. Don't forget to make
-- categores that don't exist yet using = {}
-- note: these are UPPER-CASE charcacter name
-- GLOBAL.STRINGS.CHARACTERS.WINFRED = {}
-- GLOBAL.STRINGS.CHARACTERS.WINFRED.DESCRIBE = {}
-- GLOBAL.STRINGS.CHARACTERS.WINFRED.DESCRIBE.EVERGREEN = "A template description of a tree."
GLOBAL.STRINGS.CHARACTERS.WINFRED = require "speech_winfred"

-- Let the game know Wod is a male, for proper pronouns during the end-game sequence.
-- Possible genders here are MALE, FEMALE, or ROBOT
table.insert(GLOBAL.CHARACTER_GENDERS.FEMALE, "winfred")

AddModCharacter("winfred")