local MakePlayerCharacter = require "prefabs/player_common"
--local require = GLOBAL.require

local assets = {
        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "ANIM", "anim/beard.zip" ),
		Asset( "SOUND", "sound/sfx.fsb" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/winfred.zip" ),
}

local prefabs = {}

--local prefabs = 
--{
--	"logicfilter",	
--}

--local start_inv = 
--{
--	"logicfilter",	
--}

local function custom_init(inst)

	STRINGS.CHARACTERS.WINFRED = require "speech_winfred"
end

local mitigates_rain = false

local function dohaterain(inst, dt)

--if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) then  else end

	if IsDLCEnabled(REIGN_OF_GIANTS) then 
		local mitigates_rain = inst.components.inventory:IsWaterproof()
	else
	    local mitigates_rain = inst.components.dapperness.mitigates_rain
	end
	
    if GetSeasonManager() and GetSeasonManager():IsRaining() then
	
    	if not mitigates_rain then
			inst.components.sanity.dapperness = (-TUNING.DAPPERNESS_LARGE * GetSeasonManager():GetPrecipitationRate())
			--inst.components.sanity.dapperness = (-TUNING.DAPPERNESS_HUGE * GetSeasonManager():GetPrecipitationRate())
		else
			inst.components.sanity.dapperness = (-TUNING.DAPPERNESS_MED * GetSeasonManager():GetPrecipitationRate())
			--inst.components.sanity.dapperness = (-TUNING.DAPPERNESS_LARGE * GetSeasonManager():GetPrecipitationRate())
		end
	
	else
		--if inst.components.seasonmanager.precip = true then
    	--	inst.components.sanity.dapperness = (-TUNING.DAPPERNESS_TINY)
			--inst.components.sanity.dapperness = (-0.02 )
		--else
			inst.components.sanity.dapperness = 0
		--end
	end
end	


local fn = function(inst)

	inst:AddComponent("dapperness")
	inst:DoPeriodicTask(0.2, function() dohaterain(inst, 0.2) end)
		
    --inst.components.temperature.inherentsummerinsulation = TUNING.INSULATION_SMALL
    --inst.components.temperature.inherentinsulation = TUNING.INSULATION_SMALL
    inst.components.temperature.inherentsummerinsulation = (TUNING.INSULATION_SMALL *1.5 )
    inst.components.temperature.inherentinsulation = (TUNING.INSULATION_SMALL *1.5 )

		-- seg_time = 30
		--INSULATION_TINY = seg_time,
		--INSULATION_SMALL = seg_time*2,
		--INSULATION_MED = seg_time*4,
		--INSULATION_MED_LARGE = seg_time*6,
		--INSULATION_LARGE = seg_time*8,
		
		--tune the beard economy...
		--local beard_days = {4, 8, 16}
		--local beard_bits = {1, 3,  9}
		--INSULATION_PER_BEARD_BIT = seg_time*.5,
		--WEBBER_BEARD_INSULATION_FACTOR = .75,
			
	inst.components.health:SetMaxHealth(150)
	inst.components.hunger:SetMax(150)
	inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.15)
	inst.components.sanity:SetMax(200)
	inst.components.combat.damagemultiplier = 1.0
	inst.components.combat.min_attack_period = 0.5
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.0)
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.0)
	
	-- choose which sounds this character will play
	inst.soundsname = "winfred"

	-- a minimap icon must be specified
	inst.MiniMapEntity:SetIcon( "winfredmini.png" )

end	

--return MakePlayerCharacter("winfred", prefabs, assets, fn, start_inv)
return MakePlayerCharacter("winfred", prefabs, assets, fn)